/**
    Evaluate cycle counter cost
*/

/* depend: */
/* cflags: */
/* linker: -lcycle */

#include <stdio.h>
#include <stdlib.h>

#include <snd/cycle.h>

#define CEIL(x, y) (((x) + (y) - 1) / (y))

static int n = 0;

void cycle_counter_cost (void)
{
    CYCLE_COUNTER_TIC ();
    CYCLE_COUNTER_TIC (null);
    n++;
    CYCLE_COUNTER_TOC (null);
    CYCLE_COUNTER_TOC ();
}

int main (int argc, char *argv[])
{

    int i;

    int nb_tests = (argc > 1) ? atoi (argv[1]) : 1000;

    printf ("evaluate cycle counter cost over %d tests\n", nb_tests);

    setenv ("CYCLE_COUNTERS_", "1", 1);

    for (i = 0; i < nb_tests; i++) {
        if (i % (CEIL (nb_tests, 10)) == 0) {
            printf (".");
            fflush (stdout);
        }
        cycle_counter_cost ();
    }

    //if (nb_tests % 10) printf (".");
    printf ("\n");

    display_cycle_counters ();

    return n;
}

/* vi:set tabstop=4 expandtab shiftwidth=4: this line set vi mode */
